// This file contains the definition for a roofCleaner, that is able to find edges of ceilings,
// pick up piles of beepers, put them down, get on and off of roofs.

// written by Scott McElfresh

package kareltherobot;   // part of the whole robot package


public class RoofCleaner extends TurningRobot
{
    // This is the constructor that tells us how our object gets started (in what state)
        public RoofCleaner(int street, int avenue, Direction direction, int numberOfBeepers)
        {       
           super(street, avenue, direction, numberOfBeepers);
        }

    //*****
    //finds the end of the house by checking if there is something "above" the robot.
    public void findEnd()
    {
       while (leftBlocked())
          move();
    }
    //*****
    //finds the edge of the house by checking if there is something "under" the robot.
    public void findEdge()
    {
       while (onRoof())
          move();
    
    }
   
    //*****
    // get all of the beepers at this spot
    public void getAllBeepers()
    {  
       while (beepersHere())
          pickBeeper();
    }
    //****
    // move forward till you hit a wall
    public void goToEnd()
    {  while (frontIsClear())
           move();
    }
    //****
    // Karel is facing east.  Have it get onto the roof and face west.  The roof is one to the west.
    public void climbOn()
    {
       turnLeft();
       move();
       turnLeft();
       move();
    }
    
    //****
    // Karel is facing east.  Have it get off of the roof and face west.  The roof is one to the west.
    public void climbDown()
    {
       turnRight();
       move();
       turnRight();
       move();
    }

    //*****
    // check if there is a wall to the robot's left or not.
    public boolean leftBlocked()
    {
       turnLeft();
       if (frontIsClear())
       {
          turnRight();
          return false;
       }
       else
       {
          turnRight();
          return true;
       }
    }
    
    
    //**********
    // check if the robot is still on the roof (ie, there is a wall under it)
    // ASSUMES: the robot is facing east, so checking it's right is all that is required
    public boolean onRoof()
    {
       return rightIsBlocked();
    
    }
    //********
    // check if there it is clear to the robot's right or not.
    public boolean rightIsClear()
    {
       turnRight();
       if (frontIsClear())
       {
          turnLeft();
          return true;
       }
       else
       {
          turnLeft();
          return false;
       }
    }
    //********
    // check if there is a wall to the robot's right or not.
    public boolean rightIsBlocked()
    {
        return (! rightIsClear());
    }
    
    //*****
    // are there beepers at this corner?
    public boolean beepersHere()
    {
        boolean check = nextToABeeper();
        if (check)
            return true;
        else 
            return false;
    }
    
    
}